<template>
  <div class="gp-timeline-page -position-relative">
    <div v-if="enableTasks" class="_filters _filters--no-top">
      <div class="_filters__section">
        <label class="_filters__section__title">
          <input v-model="showTasks" type="checkbox">
          {{ $t('js.timeline.display_tasks') }}
        </label>
      </div>
    </div>

    <rui-loading v-if="loading" fill relative />
    <rui-empty v-else-if="Object.keys(observations).length === 0" :content="$t('js.app.garden.page.observations.no_observations')" />

    <div v-else class="gp-timeline">
      <template v-for="year in Object.keys(entriesByYear).sort((a, b) => b-a)" :key="year">
        <template v-for="month in Object.keys(entriesByYear[year]).sort((a, b) => b-a)" :key="month">
          <!-- I18n.use $t('js.observations.month_and_year') -->
          <i18n-t :id="`month-${year}-${month}`" keypath="js.observations.month_and_year" tag="h3" class="gp-timeline__section-title gp-timeline__section-title--month">
            <template #year>
              <small class="-text--color-mute">{{ year }}</small>
            </template>
            <template #month>{{ monthName(month) }}</template>
          </i18n-t>

          <template v-for="day in Object.keys(entriesByYear[year][month]).sort((a, b) => b-a)" :key="day">
            <h4 class="gp-timeline__section-title gp-timeline__section-title--day">{{ $d(entriesByYear[year][month][day].date, 'date_and_day') }}</h4>

            <template v-for="observation in entriesByYear[year][month][day].entries" :key="observation.id">
              <component :is="entryComponent(observation)" v-bind="entryBindings(observation)" @show-image="showImage($event, observation.pictures)" />
            </template>
          </template>
        </template>
      </template>
    </div>
  </div>
</template>

<script>
import { upCaseFirst } from '@/helpers/String'
import RuiEmpty from '@experiments-labs/rise_ui/src/components/DataDisplay/Empty/Empty.vue'
import RuiLoading from '@experiments-labs/rise_ui/src/components/Loading/Loading.vue'
import GpObservationTimelineEntry from './DataDisplay/Observation/TimelineEntry.vue'
import GpTaskTimelineEntry from './DataDisplay/Task/TimelineEntry.vue'

/**
 * Timeline page
 *
 * This component is used as a page by multiple apps.
 *
 * @noPlayground
 */
export default {
  name: 'GpaTimeline',
  components: { RuiEmpty, RuiLoading, GpObservationTimelineEntry },
  props: {
    /** Whether to include tasks in the list */
    enableTasks: { required: false, type: Boolean, default: false },
    /** Props passed to timeline entries to display edition buttons or not */
    observationsEditable: { required: false, type: Boolean, default: false },
  },
  data () {
    return {
      loading: false,
      showTasks: false,
    }
  },
  computed: {
    observations () {
      return this.$store.getters.observations
    },
    tasks () {
      return this.$store.getters.tasks.filter(t => t.doneAt)
    },
    entriesByYear () {
      const results = this.observations.reduce((result, record) => {
        const year = record.madeAt.getFullYear()
        result[year] = result[year] || []
        result[year].push(record)

        return result
      }, {})

      if (this.showTasks) {
        this.tasks.reduce((result, record) => {
          const year = record.doneAt.getFullYear()
          result[year] = result[year] || []
          result[year].push(record)

          return result
        }, results)
      }

      Object.keys(results).forEach((year) => {
        results[year] = results[year].reduce((result, record) => {
          const month = record[record.className === 'Observation' ? 'madeAt' : 'doneAt'].getMonth()
          const day = record[record.className === 'Observation' ? 'madeAt' : 'doneAt'].getDate()
          result[month] = result[month] || {}
          result[month][day] = result[month][day] || { date: new Date(year, month, day), entries: [] }
          result[month][day].entries.push(record)

          return result
        }, {})
      })

      return results
    },
  },
  methods: {
    entryComponent (entry) {
      switch (entry.className) {
        case 'Task': return GpTaskTimelineEntry
        case 'Observation': return GpObservationTimelineEntry
        default: throw new Error('Unsupported entry type')
      }
    },
    entryBindings (entry) {
      switch (entry.className) {
        case 'Task': return { task: entry }
        case 'Observation': return { observation: entry, showActions: this.observationsEditable }
        default: throw new Error('Unsupported entry type')
      }
    },
    showImage (url, urls) {
      const list = urls.map(links => links.source)

      this.$emitBus('show-image', {
        list,
        selected: url,
      })
    },
    monthName (monthNumber) {
      return upCaseFirst(this.$t(`date.month_names.${parseInt(monthNumber, 10) + 1}`))
    },
    loadTasks () {
      this.loading = true
      this.$store.dispatch('loadTasksAllForMap', { mapId: this.$route.params.mapId || this.$mapId })
        .then().then(() => {
          this.loading = false
        })
    },
  },
  created () {
    this.loading = true
    this.$store.dispatch('loadObservationsByMap', this.$route.params.mapId || this.$mapId)
      .then(() => { this.loading = false })
  },
  watch: {
    showTasks (newValue) {
      if (newValue && this.tasks.length === 0) this.loadTasks()
    },
  },
}
</script>
